/* db-db-detail-file-filter.p */
DEFINE TEMP-TABLE tt-db             NO-UNDO  LIKE _Db.
DEFINE TEMP-TABLE tt-db-detail      NO-UNDO  LIKE _Db-Detail.
DEFINE TEMP-TABLE tt-file           NO-UNDO  LIKE _File.

DEFINE DATA-SOURCE dsrc-db          FOR   _Db.
DEFINE DATA-SOURCE dsrc-db-detail   FOR   _Db-Detail.
DEFINE DATA-SOURCE dsrc-file        FOR   _File.

DEFINE DATASET pds-db-struct        
   FOR   tt-db, 
         tt-db-detail, 
         tt-file

   DATA-RELATION r1 
      FOR tt-db, 
          tt-db-detail 
      RELATION-FIELDS(_db-guid, _db-guid)
                    
   PARENT-ID-RELATION r2 
      FOR  tt-db, 
           tt-file
      PARENT-ID-FIELD _db-recid.

BUFFER tt-db:ATTACH-DATA-SOURCE(DATA-SOURCE dsrc-db:HANDLE).
BUFFER tt-db-detail:ATTACH-DATA-SOURCE(DATA-SOURCE dsrc-db-detail:HANDLE).
BUFFER tt-file:ATTACH-DATA-SOURCE(DATA-SOURCE dsrc-file:HANDLE).

DATA-SOURCE dsrc-file:FILL-WHERE-STRING = "WHERE _File._Tbl-Type = ""T""".

DATASET pds-db-struct:FILL().

FOR EACH tt-db NO-LOCK:
    DISPLAY tt-db._db-name 
            tt-db._db-type
            tt-db._db-guid 
        WITH FRAME f-db 2 DOWN.
END. 

FOR EACH tt-db-detail NO-LOCK:
    DISPLAY tt-db-detail._Db-description    FORMAT "X(15)"       
            tt-db-detail._Db-guid              
        WITH FRAME f-detail 2 DOWN.
END. 

FOR EACH tt-file:
    DISPLAY tt-file._file-name 
            tt-file._tbl-type
        WITH DOWN.
END.  