/* db-file-filter-callback.p */

DEFINE TEMP-TABLE tt-db       NO-UNDO  
   LIKE  _Db
   FIELD _Db-recid AS RECID.
   
DEFINE TEMP-TABLE tt-file     NO-UNDO  
   LIKE _File.

DEFINE DATA-SOURCE dsrc-db    FOR _Db.
DEFINE DATA-SOURCE dsrc-file  FOR _File.

DEFINE DATASET pds-db-file    
   FOR tt-db, 
       tt-file
   PARENT-ID-RELATION db-file 
      FOR   tt-db, 
            tt-file
      PARENT-ID-FIELD _db-recid                    
      .

BUFFER tt-db:ATTACH-DATA-SOURCE(DATA-SOURCE dsrc-db:HANDLE).
BUFFER tt-file:ATTACH-DATA-SOURCE(DATA-SOURCE dsrc-file:HANDLE).

DATA-SOURCE dsrc-file:FILL-WHERE-STRING = "WHERE _File._Tbl-Type = ""T""".

BUFFER tt-db:SET-CALLBACK-PROCEDURE("AFTER-ROW-FILL", 
                                    "AfterRowFill", 
                                    THIS-PROCEDURE).
                                    
DATASET pds-db-file:FILL().

FOR EACH tt-db NO-LOCK:
 DISPLAY 
     tt-db._db-type
     tt-db._db-guid
     STRING(tt-db._db-recid)  COLUMN-LABEL "Db!Recid" 
   WITH FRAME f-db. 
END.  

FOR EACH tt-file:
  DISPLAY tt-file._file-name 
          tt-file._tbl-type
          STRING(tt-file._db-recid) COLUMN-LABEL "Db!Recid"
    WITH DOWN.
END.  

/****************************************************************************/
PROCEDURE AfterRowFill:
DEFINE INPUT PARAMETER DATASET FOR pds-db-file.
ASSIGN tt-Db._Db-recid = RECID(_db).
END PROCEDURE.
