{pdsDefinitions.i}

DEFINE INPUT-OUTPUT PARAMETER DATASET   FOR pdsSchema.
DEFINE INPUT-OUTPUT PARAMETER ilSeq     AS INT64 NO-UNDO.

DEFINE DATA-SOURCE dsrcDb           FOR dictdb._db.
DEFINE DATA-SOURCE dsrcFile         FOR dictdb._file.
DEFINE DATA-SOURCE dsrcField        FOR dictdb._field.
DEFINE DATA-SOURCE dsrcIndex        FOR dictdb._Index.
DEFINE DATA-SOURCE dsrcIndexField   FOR dictdb._index-field.

BUFFER ttDb:SET-CALLBACK-PROCEDURE(         "after-row-fill", "DbAfterRowFill"). 
BUFFER ttFile:SET-CALLBACK-PROCEDURE(       "after-row-fill", "FileAfterRowFill"). 
BUFFER ttField:SET-CALLBACK-PROCEDURE(      "after-row-fill", "FieldAfterRowFill"). 
BUFFER ttIndex:SET-CALLBACK-PROCEDURE(      "after-row-fill", "IndexAfterRowFill"). 
BUFFER ttIndexField:SET-CALLBACK-PROCEDURE( "after-row-fill", "IndexFieldAfterRowFill"). 

BUFFER ttDb:ATTACH-DATA-SOURCE(         DATA-SOURCE dsrcDb:HANDLE).
BUFFER ttFile:ATTACH-DATA-SOURCE(       DATA-SOURCE dsrcFile:HANDLE).
BUFFER ttField:ATTACH-DATA-SOURCE(      DATA-SOURCE dsrcField:HANDLE).
BUFFER ttIndex:ATTACH-DATA-SOURCE(      DATA-SOURCE dsrcIndex:HANDLE).
BUFFER ttIndexField:ATTACH-DATA-SOURCE( DATA-SOURCE dsrcIndexField:HANDLE).

BUFFER ttDb:FILL-MODE           = "APPEND".
BUFFER ttFile:FILL-MODE         = "APPEND".
BUFFER ttField:FILL-MODE        = "APPEND".
BUFFER ttIndex:FILL-MODE        = "APPEND".
BUFFER ttIndexField:FILL-MODE   = "APPEND".
    
/* Exlcude VSTs and the like    */
DATA-SOURCE dsrcFile:FILL-WHERE-STRING = "WHERE _file-number > 0 and _file-number < 32767".

DATASET pdsSchema:FILL().

BUFFER ttDb:DETACH-DATA-SOURCE().
BUFFER ttFile:DETACH-DATA-SOURCE().
BUFFER ttField:DETACH-DATA-SOURCE().
BUFFER ttIndex:DETACH-DATA-SOURCE().
BUFFER ttIndexField:DETACH-DATA-SOURCE().

BUFFER ttDb:SET-CALLBACK-PROCEDURE(         "after-row-fill", ""). 
BUFFER ttFile:SET-CALLBACK-PROCEDURE(       "after-row-fill", ""). 
BUFFER ttField:SET-CALLBACK-PROCEDURE(      "after-row-fill", ""). 
BUFFER ttIndex:SET-CALLBACK-PROCEDURE(      "after-row-fill", ""). 
BUFFER ttIndexField:SET-CALLBACK-PROCEDURE( "after-row-fill", ""). 

PROCEDURE DbAfterRowFill:
DEFINE INPUT PARAMETER DATASET FOR pdsSchema.

ASSIGN 
    ilSeq               = ilSeq + 1
    ttDb._db-recid      = RECID(dictdb._db)
    ttDb.DatabaseID     = ilSeq
    ttDb._db-name       = BUFFER dictdb._db:DBNAME 
    .

END PROCEDURE.

PROCEDURE FileAfterRowFill:
DEFINE INPUT PARAMETER DATASET FOR pdsSchema.

ASSIGN 
    ttFile._db-recid    = ttDb._db-recid
    ttFile.DatabaseID   = ttDb.DatabaseID
    ttFile._db-name     = ttDb._db-name 

    ilSeq               = ilSeq + 1
    ttFile.FileID       = ilSeq
    ttFile._file-recid  = RECID(dictdb._file)
    .

END PROCEDURE.

PROCEDURE FieldAfterRowFill:
DEFINE INPUT PARAMETER DATASET FOR pdsSchema.

ASSIGN
    ttField._db-recid       = ttFile._db-recid
    ttField.DatabaseID      = ttFile.DatabaseID
    ttField._db-name        = ttFile._db-name        

    ttField._file-recid     = ttFile._file-recid
    ttField.FileID          = ttFile.FileID
    ttField._file-name      = ttFile._file-name

    ilSeq                   = ilSeq + 1
    ttField.FieldID         = ilSeq
    ttField._field-recid    = RECID(dictdb._field)
    .


END PROCEDURE.

PROCEDURE IndexAfterRowFill:
DEFINE INPUT PARAMETER DATASET FOR pdsSchema.

ASSIGN 
    ttIndex._db-recid       = ttFile._db-recid
    ttIndex.DatabaseID      = ttFile.DatabaseID
    ttIndex._db-name        = ttFile._db-name        

    ttIndex._file-recid     = ttFile._file-recid
    ttIndex.FileID          = ttFile.FileID
    ttIndex._file-name      = ttFile._file-name

    ilSeq                   = ilSeq + 1
    ttIndex.IndexID         = ilSeq
    ttIndex._index-recid    = RECID(dictdb._index)
    .

END PROCEDURE.

PROCEDURE IndexFieldAfterRowFill:
DEFINE INPUT PARAMETER DATASET FOR pdsSchema.

DEFINE BUFFER ttField FOR ttField.

FIND ttField 
    WHERE ttField._db-name      = ttIndex._db-name 
    AND   ttField._field-recid  = ttIndexField._field-recid
    NO-LOCK NO-ERROR.

ASSIGN 
    ttIndexField._db-recid          = ttIndex._db-recid
    ttIndexField.DatabaseID         = ttIndex.DatabaseID
    ttIndexField._db-name           = ttIndex._db-name        

    ttIndexField._file-recid        = ttIndex._file-recid
    ttIndexField.FileID             = ttIndex.FileID
    ttIndexField._file-name         = ttIndex._file-name

    ttIndexField._index-recid       = ttIndex._Index-recid
    ttIndexField.IndexID            = ttIndex.IndexID
    ttIndexField._Index-name        = ttIndex._index-name
    
    ttIndexField._field-recid       = ttField._field-recid WHEN AVAILABLE ttField
    ttIndexField.FieldID            = ttField.FieldID      WHEN AVAILABLE ttField
    ttIndexField._field-name        = ttField._field-name  WHEN AVAILABLE ttField
    ttIndexField._data-type         = ttField._data-type   WHEN AVAILABLE ttField

    ilSeq                           = ilSeq + 1
    ttIndexField.IndexFieldID       = ilSeq
    ttIndexField._index-field-recid = RECID(dictdb._index-field)
    .

END PROCEDURE.
