{pdsDefinitions.i   }

DEFINE VARIABLE iDbCnt          AS INTEGER      NO-UNDO.
DEFINE VARIABLE chDbName        AS CHARACTER    NO-UNDO.
DEFINE VARIABLE ilSeq           AS INT64        NO-UNDO.

RUN setup.

DO iDbCnt = 1 TO NUM-DBS:

    DISPLAY 
            LDBNAME(iDbCnt) COLUMN-LABEL "Loading DB" FORMAT "X(40)"
        WITH DOWN.

    RUN SetDictDb.p(LDBNAME(iDbCnt)).
    RUN ReadSchemaData.p(   INPUT-OUTPUT DATASET pdsSchema BY-REFERENCE, 
                            INPUT-OUTPUT ilSeq
                            ).
    DOWN.

END.

RUN SetDictDb.p(LDBNAME(1)).

RUN DumpSchemaData.p( DATASET pdsSchema BY-REFERENCE, 
                      "U:\Systems\VPASRel15-Dev\Common\DbSchema"
                      ).
 
MESSAGE "done"
  VIEW-AS ALERT-BOX.
  
PROCEDURE setup:
/* One time actions which don't need to be done for each db */
DATASET pdsSchema:ADD-RELATION( BUFFER ttDb:HANDLE, 
                                BUFFER ttFile:HANDLE, 
                                "_db-recid,_db-recid"
                                ).

DATASET pdsSchema:ADD-RELATION( BUFFER ttFile:HANDLE, 
                                BUFFER ttField:HANDLE, 
                                "_file-recid,_file-recid"
                                ).

DATASET pdsSchema:ADD-RELATION( BUFFER ttFile:HANDLE, 
                                BUFFER ttIndex:HANDLE, 
                                "_file-recid,_file-recid"
                                ).

DATASET pdsSchema:ADD-RELATION( BUFFER ttIndex:HANDLE, 
                                BUFFER ttIndexField:HANDLE, 
                                "_index-recid,_index-recid"
                                ).


END PROCEDURE.

