
DEFINE TEMP-TABLE ttDb 
    LIKE Dictdb._Db
    FIELD _db-recid     AS RECID 
    FIELD DatabaseID    AS INT64 
    INDEX ixDbRecid     _db-name 
                        _db-recid 

    INDEX ixDbID        DatabaseID
    .

DEFINE TEMP-TABLE ttFile
    LIKE Dictdb._file
    FIELD _db-name      AS CHARACTER 
    FIELD DatabaseID    AS INT64 

    FIELD _file-recid   AS RECID 
    FIELD FileID        AS INT64 
    
    INDEX ixDbFileName  _db-name 
                        _file-name 

    INDEX ixDbFileRecid _db-name 
                        _file-recid 

    INDEX ixDbID        DatabaseID

    INDEX ixFileDbID    FileID 
                        DatabaseID
    .

DEFINE TEMP-TABLE ttField 
    LIKE dictdb._field

    FIELD _db-name      AS CHARACTER 
    FIELD _db-recid     AS RECID 
    FIELD DatabaseID    AS INT64 
    
    FIELD _file-name    AS CHARACTER 
    FIELD FileID        AS INT64 

    FIELD _field-recid  AS RECID 
    FIELD FieldID       AS INT64 

    INDEX ixDbFile          _db-name 
                            _file-name 
                            _field-name 

    INDEX ixDbField         _db-name 
                            _field-recid 

    INDEX ixFileFieldbID    FileId
                            FieldId

    INDEX ixFieldFileID     FieldID
                            FileID 
    .

DEFINE TEMP-TABLE ttIndex 
    LIKE dictdb._index

    FIELD _db-name      AS CHARACTER 
    FIELD _db-recid     AS RECID 
    FIELD DatabaseID    AS INT64 

    FIELD _file-name    AS CHARACTER 
    FIELD FileID        AS INT64 

    FIELD _index-recid  AS RECID 
    FIELD IndexID       AS INT64 

    INDEX ixDbFileIndex _db-name 
                        _file-name 
                        _index-name 

    INDEX idDbIndex     _db-name 
                        _index-recid
    
    INDEX ixFileIndex   FileId
                        IndexId

    INDEX ixIndexID     IndexID
                        FileId
    .


DEFINE TEMP-TABLE ttIndexField 
    LIKE dictdb._index-field

    FIELD _db-name              AS CHARACTER 
    FIELD _db-recid             AS RECID 
    FIELD DatabaseID            AS INT64 

    FIELD _file-name            AS CHARACTER 
    FIELD _file-recid           AS RECID 
    FIELD FileID                AS INT64 

    FIELD _index-name           AS CHARACTER 
    FIELD IndexID               AS INT64 
    
    FIELD _field-name           AS CHARACTER 
    FIELD FieldID               AS INT64 
    FIELD _data-type            AS CHARACTER 

    FIELD _index-field-recid    AS RECID 
    FIELD IndexFieldID          AS INT64 

    INDEX ixDbFileIxIxFld       _db-name 
                                _file-name 
                                _index-name 
                                _field-name

    INDEX ixDbFileIxIxFldRecid  _db-name 
                                _file-name 
                                _index-name 
                                _index-field-recid
    
    INDEX ixDbID                DatabaseID

    INDEX ixFileID              FileID

    INDEX ixIndexFieldID        IndexFieldID

    INDEX ixFieldID             FieldID
    .




    
